Bug 1218074 (CVE-2015-3636) - CVE-2015-3636 kernel: ping sockets: use-after-free leading to local privilege escalation
Summary: CVE-2015-3636 kernel: ping sockets: use-after-free leading to local privilege...
Status: CLOSED ERRATA
Alias: CVE-2015-3636
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=moderate,public=20150502,repor...
Keywords: Security
Depends On: 1218100 1218101 1218102 1218103 1218104 1218105 1218106 1218107 1218108 1218110 1218112 1218113
Blocks: 1218075
TreeView+ depends on / blocked
 
Reported: 2015-05-04 07:53 UTC by Petr Matousek
Modified: 2019-06-11 11:13 UTC (History)
30 users (show)

(edit)
It was found that the Linux kernel's ping socket implementation did not properly handle socket unhashing during spurious disconnects, which could lead to a use-after-free flaw. On x86-64 architecture systems, a local user able to create ping sockets could use this flaw to crash the system. On non-x86-64 architecture systems, a local user able to create ping sockets could use this flaw to escalate their privileges on the system.
Clone Of:
(edit)
Last Closed: 2019-06-08 02:41:00 UTC


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2015:1221 normal SHIPPED_LIVE Moderate: kernel security, bug fix, and enhancement update 2015-07-14 19:12:10 UTC
Red Hat Product Errata RHSA-2015:1534 normal SHIPPED_LIVE Moderate: kernel security and bug fix update 2015-08-06 06:42:13 UTC
Red Hat Product Errata RHSA-2015:1564 normal SHIPPED_LIVE Moderate: kernel-rt security, bug fix, and enhancement update 2015-08-05 22:49:08 UTC
Red Hat Product Errata RHSA-2015:1565 normal SHIPPED_LIVE Moderate: kernel-rt security, bug fix, and enhancement update 2015-08-06 00:13:24 UTC
Red Hat Product Errata RHSA-2015:1583 normal SHIPPED_LIVE Moderate: kernel security and bug fix update 2015-08-11 18:39:42 UTC
Red Hat Product Errata RHSA-2015:1643 normal SHIPPED_LIVE Moderate: kernel security and bug fix update 2015-08-18 22:38:21 UTC

Description Petr Matousek 2015-05-04 07:53:34 UTC
It was found that the Linux kernel's ping socket implementation didn't properly
handle socket unhashing during spurious disconnects which could lead to
use-after-free flaw.

On x86-64 architecture systems, a local user able to create ping sockets could
use this flaw to crash the system.

On non-x86-64 architecture systems, a local user able to create ping sockets
could use this flaw to increase their privileges on the system.

Note: By default ping sockets are disabled on the system
(net.ipv4.ping_group_range = 1	0) and have to be explicitly enabled by the
system administrator for specific user groups in order to exploit this issue.

Upstream fix:
https://github.com/torvalds/linux/commit/a134f083e79fb4c3d0a925691e732c56911b4326

References:
http://www.openwall.com/lists/oss-security/2015/05/02/5

Comment 6 Petr Matousek 2015-05-04 08:37:39 UTC
Created kernel tracking bugs for this issue:

Affects: fedora-all [bug 1218110]

Comment 8 Petr Matousek 2015-05-04 08:44:38 UTC
Statement:

This issue does not affect the Linux kernel as shipped with Red Hat Enterprise Linux 5. This issue does affect the Linux kernel as shipped with Red Hat Enterprise Linux 6, 7 and Red Hat Enterprise MRG 2. Future kernel updates for the respective releases will address this issue.

Please note that on x86-64 architecture systems the impact is limited to local Denial of Service and that the ping sockets functionality is disabled by default (net.ipv4.ping_group_range sysctl is "1	0").

Comment 9 Petr Matousek 2015-05-04 08:54:10 UTC
Mitigation:

You can check whether ping socket functionality is enabled by examining the net.ipv4.ping_group_range sysctl value:

~]# sysctl net.ipv4.ping_group_range
net.ipv4.ping_group_range = 1	0

"1 0" is the default value and disables the ping socket functionality even for root user. Any other value means that the ping socket functionality might be enabled for certain users on the system.

To mitigate this vulnerability make sure that you either allow the functionality to trusted local users (groups) only or set the net.ipv4.ping_group_range sysctl to the default and disabled state:

~]# sysctl net.ipv4.ping_group_range="1 0"

Please note that this might prevent some programs relying on this functionality from functioning properly.

Comment 10 Fedora Update System 2015-05-11 19:03:15 UTC
kernel-4.0.2-300.fc22 has been pushed to the Fedora 22 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2015-05-12 20:40:55 UTC
kernel-3.19.7-200.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 12 Fedora Update System 2015-05-26 03:56:00 UTC
kernel-3.19.8-100.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 13 errata-xmlrpc 2015-07-14 15:14:55 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6

Via RHSA-2015:1221 https://rhn.redhat.com/errata/RHSA-2015-1221.html

Comment 14 errata-xmlrpc 2015-08-05 18:49:43 UTC
This issue has been addressed in the following products:

  MRG for RHEL-6 v.2

Via RHSA-2015:1564 https://rhn.redhat.com/errata/RHSA-2015-1564.html

Comment 15 errata-xmlrpc 2015-08-05 20:14:07 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2015:1565 https://access.redhat.com/errata/RHSA-2015:1565

Comment 16 errata-xmlrpc 2015-08-06 02:43:07 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2015:1534 https://rhn.redhat.com/errata/RHSA-2015-1534.html

Comment 17 errata-xmlrpc 2015-08-11 14:40:32 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6.5 EUS - Server and Compute Node Only

Via RHSA-2015:1583 https://rhn.redhat.com/errata/RHSA-2015-1583.html

Comment 18 errata-xmlrpc 2015-08-18 18:38:34 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6.4 AUS - Server Only

Via RHSA-2015:1643 https://rhn.redhat.com/errata/RHSA-2015-1643.html


Note You need to log in before you can comment on or make changes to this bug.